







                              M M S C A N




                  User Manual and Installation Guide
































                                        by: DL1BJL and VE3FD

                                             February 1995
       


       INDEX



       1. MMScan - a mailer with a difference  .................  1

       2. Distribution terms and conditions  ...................  2

       3. Installation  ........................................  3

       4. How to use MMScan  ...................................  5

           Navigating the -

           1. Opening screen  ..................................  5

           2. Editor  ..........................................  8

           3. Mail in-queue inquiry screen  ....................  9

           4. Mail browser  .................................... 10

           5. Mail reader/viewer ............................... 13

           6. Directory file viewer/browser window ............. 14


       5. Appendix

           1. MIME implemention in MMScan  ..................... 15

           2. Extract of RFC 1341  ............................. 15

           3. Version history  ................................. 22



                                      -1-




       1. MMScan - a mailer with a difference
       --------------------------------------

       The reasons to built yet another mailer were many, but can
       mainly be ascribed to certain limitations of most DOS based
       mailers.
       When JNOS (as of version 1.10) offered NNTP message
       swapping to SMTP if the host was configured accordingly
       (as NNTP client), the idea to incorporate features into
       the mailer, allowing NNTP mail 'processing', was both
       fascinating and opportune.

       Over time and as the result of the ardent insistence of
       Heri, VE3FD and other OMs for 'bells and whistles' during
       beta development, the initial concept of a simple mailer
       matured into the current product.

       Thus, the mailer 'sports' the following features:

       . use for regular mail or news net mail if host is configured
         as NNTP client with NNTP swapping to SMTP;
       . user definable variables like mail path and colour
         definitions in configuration file as well as potential
         override of DOS environmental variables;
       . calculates GMT in relation to your time zone to show in
         message header;
       . fully configurable to select your favourite editor and
         viewer;
       . built in editor features extensive text editing
         capabilities and definable right margin;
       . on line help for built in editor;
       . tracking and display of up to 30 mailboxes (areas)
         containing up to 400 pieces of mail;
       . limited MIME implementation integrated right into the
         program - there is no need for external programs (see Appendix
         for details);
       . ability to bounce or forward with multiple copy
         distribution;
       . allows copying of mail to other areas;
       . nifty and timesaving implementation of alias expansion
         in the message address;
       . batch manipulation of mail through tag functions;
       . mail forward allows comments to be included in
         forwarded message;
       . very user friendly - most utilized commands displayed
         on status lines;
       . last but not least - the mailer is freeware.

         Note : MMScan has been testet with JNOS and WNOS
       
                                      -2-




       2. Distribution Terms and Conditions
       ------------------------------------

       MMScan (Mat's mail scanner) is FREEWARE and not public domain or
       shareware. The software is distributed under the following
       conditions:

       - It may only be used for Amateur Radio purposes.
       - In no event shall the authors be liable for incidental or
         consequential damage in connection with or arising out of
         the furnishing, performance, or use of any of the files in the
         package.
       - The program may be copied and re-distributed provided it is
         distributed complete with documentation and in unmodified form.
       - The program is Copyright 1994/1995 by Matthias Wermann, DL1BJL and
         Heribert Riesbeck, VE3FD and it may not be used for any purpose
         by any commercial organization, or re-distributed by anyone for
         a fee or any monetary consideration.


                            * * * * * * * * * *


       The distribution package may be ARJed or ZIPped and contains the
       following files when uncompressed:

       -  mmscan12.exe ---- the executable mailer for version 1.2
       -  mmscan.cfg   ---- configuration file
       -  mmscan.man   ---- the manual - a text file

                            - - - - - - - - - -

       The program will be available for downloading at:

       - mpt.et-inf.fho-emden.de (192.129.16.102) FTP,
       - mpt.et-inf.fho-emden.de (192.129.16.102) FSP (port 21 UDP),
       - sys2.db0fho.ampr.org (44.130.12.36) FTP, in directory:
          /pub/hamradio/tcpip/mmscan



       Comments and suggestions for improvements should be sent to:

       mmscan@db0fho.ampr.org or mmscan@db0fho.et-inf.fho-emden.de

       
                                      -3-




       3. Installation
       ---------------

       The following are suggested installation steps:


       1. Unarchive file into an empty directory.

       2. Type 'mmscan' and ENTER to start mailer. It will create a
       configuration file 'mmscan.cfg' which must be edited to reflect
       your operating environment and parameters.

       3. MMScan uses the following parameters from the configuration
       file.

       - MAILDIR=drive and path of your mail directory.
       - BROWSER=+builtin (default). Leave default if you are planning to
         use the default browser (viewer), otherwise provide drive, path
         and filename pointing to your favourite viewer. See also note 1
         below.
       - EDITOR=+builtin (default). Provide drive, path and
         filename of your favourite editor if you do not want to use the
         built in editor. See also note 1 below.
       - MQUEUE=drive and path of your mail queue directory.
       - SEQUENCE=sequence.seq (default if omitted).
       - ALIAS=drive, path and name of your alias file.
       - SIGNATURE=drive, path and name of your signature file.
       - MAILHOST=call of your mail host, e.g something.ampr.org. See note 2.
       - MAILUSER=Insert your username, e.g. your callsign. See note 2.
       - FULLNAME=Provide full name or leave blank. See note 2.
       - REPLY-TO=Provide complete reply address. See note 2.
       - TIMEZONE=Enter your time zone and the number of hours difference
         in relation to GMT. e.g. EST5. Use positive value west of Long.0
         and a negative value east of Greenwich. The values defined  h e r e
         will be used in the GMT calculation, unlike the TZ (time zone)
         definition set in the autoexec.bat file.
       - LPT=LPT1 (default if omitted). Define port of printing device.
       - COLORS=define colour scheme - colours 1 to 15;
       
                                      -4-



       The colour definition and the position in the array are as follows:

       Array position: 1- Normal background
                       2- Background of bar
                       3- Status Bar
                       4- Commands
                       5- SMTP
                       6- Highlighted menu
                       7- Status Menu
                       8- Menu
                       9- Menu header
                      10- Highlighted characters
                      11- Activity indicator
                      12- Version indicator


       The colours and their corresponding values are as follows:

       Value Colour
       ----- ------
         0   black
         1   blue
         2   green
         3   cyan
         4   red
         5   magenta
         6   brown
         7   light grey
         8   dark grey
         9   light blue
        10   light green
        11   light cyan
        12   light red
        13   light magenta
        14   yellow
        15   white


       Installation steps continued;

       4. Set environmental variable in the autoexec.bat file where
       mmscan will reside (ex. set mmscan=c:\nos )
       5. Copy the MMScan program and the mmscan.cfg file into the
       'default' directory.


       Note 1: The help features are only available with the built in
               viewer and editor.
       Note 2: These items will be shown in the message header.
       
                                      -5-




       4. How to use MMScan
       --------------------


       The mailer consists essentially of five major screens. They are
       (1) the opening screen, (2) the editor, (3) the mail in queue
       inquiry screen, (4) the mail browser index screen, (5) the
       mail viewer/reader screen and (6) the directory
       viewer/browser window.


                (1) Navigating the Opening Screen

       The opening screen as any other of the five screens consists of a
       top and bottom status line and the inquiry or editor screen area
       in the middle as the case may be. From here the following commands
       can be executed and only the highlighted command letter need be
       entered:

       View alias       Allows viewing and manipulation of alias file
       delete box       To delete an entire mail box or mail area
       rescan Boxes     Activates rescanning and indexing of arriving mail
       mail Msg         This command calls up the editor
       tx File          To transmit a file via 'e-mail'
       queue Status     Allows inquiry on and further manipulation of
                        queued mail
       Edit             Invokes the built-in editor

       The bottom status line indicates the cursor movement keys and
       control available while navigating. In addition, when depressing
       upper case 'I' an important message pertaining to the mailer is
       displayed.

       The mail box index - centre part of the screen - shows the name of
       the box and its corresponding total size of the messages stored
       including the number of messages and any new or unread messages.
       In addition, a mailbox summary indicates the total size, number
       of messages and new unread messages. The new messages of each box
       are conveniently highlighted.

       The following is a more detailed description of the various
       commands executable from the opening screen.
       
                                      -6-



       >>> View alias <<<

       Depressing 'a' requests further choices as to editing (e) or
       viewing (v) of the alias file. The features of the editor and the
       reader/viewer will be discussed later.


       >>> delete Box <<<

       Move the highlighted cursor bar to the mail box you wish to delete
       and press Enter. You will be prompted if you really wish to delete
       the box. Your choice can only be 'y' or 'n'.


       >>> rescan Boxes <<<

       Refreshes display to show mail which arrived while in a NOS shell.


       >>> mail Msg <<<

       Depressing 'm' will present you with the prompt 'Mail To:' Your
       entry can either be a complete address or one or several aliases.
       If a regular (non alias) address is entered, depressing the TAB
       key will insert '.ampr.org' after the mailbox call.
       This is an opportune time to briefly digress and explain the
       features of the line editor which come into play when manipulating
       the contents of the 'TO', 'Cc' and 'SUBJECT' fields (applicable
       throughout MMScan). Text in these fields can be erased quickly by
       depressing the ESC key. The 'Home' and 'End' keys move the cursor
       to the beginning and end of the typed text, respectively. In
       addition, the line editor is automatically in the 'character
       insert' mode. The arrow-keys move the cursor left/right.
       Now, let's get back to the alias expansion feature. The mailer
       will expand aliases according to the algorithm described below. As
       this is quite an elaborate description, it is illustrated only at
       this time but it will be applicable to all modules in MMScan
       were addresses are expanded by aliases.
                                 * * *
       Essentially, only one address or alias is allowed in the 'mail
       to' field. All other aliases are bumped to the 'Cc (carbon copy)'
       field. Thus if an alias in the 'mail to' field expands to two or
       more addresses, they will be moved to the 'Cc' field. - While
       expanding aliases, MMScan creates copies of the original message
       based on the corresponding contents of the alias file entry or
       entries, but still maintaining the original message header address.
       SMTP will move the message(s) based on the addressing found in the
       *.wrk file(s). - Should the expansion of the 'Cc' field generate
       duplicate addresses, only one will be kept. - Entries in the 'Cc'
       
                                      -7-



       field must be separated by a SINGLE SPACE. - Recursive alias
       processing up to a depth of two passes is possible after which the
       destination address  m u s t  be established.
       A short example will illustrate the process, considering the
       following entries in an 'hypothetical' alias file:

       mmscanusers mmscan pe1oid cosysop uwe
       sysops sysop cosysop
       heri ve3fd@ve3fd.ampr.org
       cosysop dg4bcj@db0fho.ampr.org
       uwe dl8bcz@db0fho.ampr.org
       mmscan mmscan@db0fho.ampr.org


       Now let us compose the address> Mail to: mmscanusers Cc: sysops

       This will at first expand to> Mail to: mmscan Cc: pe1oid cosysop
                                                         heri uwe sysop

       In the second pass, when saving the message, the remaining aliases
       will be expanded to create the following messages addressed to:

       mmscan@db0fho.ampr.org
       pe1oid
       dg4bcj@db0fho.ampr.org
       ve3fd@ve3fd.ampr.org
       dl8bcz@db0fho.ampr.org
       sysop
                                 * * *

       To continue with composing the message, the next field which
       will be presented is the Subject field. This field may be left
       blank as is desirable when subscribing to lists. Upon depressing
       the Enter key, the editor screen will be presented. The editing
       features will be described in chapter 4.2.


       >>> tx File <<<

       Upon entering 't', a mailing address will be requested which
       should be either a complete address or an alias. Carbon copying
       is offered as well with this feature. The same expansion features
       as described above will apply here as well.
       Next, the user will be prompted for the path and the name of the
       file. If the path and filename are not known, the entry can be
       left blank and the file directory browser window can be activated
       by simply depressing ENTER. The functions of this feature will be
       covered in chapter 4.6.
       
                                      -8-



       If the file to be transmitted is a binary file, MMScan will sense
       the characteristics of the file and will automatically convert it
       to ASCII characters using MIME base 64 octet stream conversion to
       conform with SMTP data transmission standards. MIME conversion
       and the corresponding RFCs which define MIME are briefly
       described in the chapter 5.2 of the appendix.
       In case the file to be transmitted is a text file, no
       conversion will take place.

       The 'Subject' prompt, which follows the 'Cc' prompt, has the name
       of the file pre-loaded, but allows modification of the field contents.
       The last prompt requests confirmation of the intended action. If
       affirmative, the file(s) is (are) stored in the mail queue
       subdirectory based on addressing and/or alias expansion.


       >>> queue Status <<<

       When entering 'q' a mail queue status screen is presented. Its
       features will be discussed in chapter 4.3.


       >>> Edit <<<

       Depressing 'E' will call up the built-in editor or the editor of
       your choice, if configured. This feature is useful to edit text of
       a file which might be added or included in mail or for any other
       reason. However, this function also allows editing of completely new
       files. The functions of the editor will be described next.

       Note: All screens can be exited or escaped with the ESC command
             key, except as indicated.




                (1) Navigating the Editor


       The built-in editor is a full screen editor and employs Wordstar
       like commands. The screen is divided into 3 parts. The status line
       on top of the screen conveniently shows which file is being edited,
       the remaining buffer space and cursor position coordinates, word wrap-
       and right margin screen columns, as well as the insert and
       indentation toggle status indicator. These 'editor preferences' and
       other editing features can be commanded by the familiar ^charchar
       strings. The full command set, applicable to the editor, is shown
       in the on line help menu. The help menu is accessed by way auf the
       standard F1 function key.
       
                                      -9-



       The line 25 on the bottom of the screen displays the most
       commonly used editor functions pre-programmed on function keys.
       The command line editor allows free movement of the cursor in all
       four axes using the arrow keys. Additional short cut keys are, the
       page up and down keys to move rapidly back and forth in the text,
       and the ESC key will delete the entire line where the cursor is
       located.

       Some of the pre-programmed function keys warrant special explanation,
       due to unique features they provide.
       The F2 key is used to exit completed text and initiate 'save' action.
       The F10 will exit the editor and discard all previously
       typed or imported text, however the user is prompted to confirm
       intended deletion action.
       The F4 key allows insertion (importing) of an ASCII text
       (Important ! - binary not allowed). This attach-like feature
       should be used to copy a message or other ASCII text to the
       message which is being composed. The text should be reasonably
       short in order not to overflow the available buffer space. If
       longer text is to be transmitted, the 'tx File' feature should be
       used.
       Furthermore, the F4 key also invokes the directory file browser mode
       which opens a window on the screen to display the current directory
       and corresponding files. The features of the directory file
       browser is described in detail in chapter 4.6.

       It should be noted, that the above described functionality is not
       available if a user defined editor in lieu of the built-in editor
       is used.

       The centre part of the screen is the editor work space. On
       startup, the screen is in insert mode and the cursor is
       conveniently in position on the top left hand corner of the screen
       and just above the users pre-defined signature text, ready to
       commence composing the message.




                (3) Navigating the Mail-In-Queue Inquiry Screen


       When selecting 'q' from the opening screen, the mailer lists all
       mails in the queue to be transmitted. The bottom status line
       displays commands which can be activated from this screen. Besides
       deleting and unlocking a job, the edit feature allows to make
       last minute modifications or corrections of an address or the text
       itself. To this end a choice is offered to edit the work (w) or
       text (t) file. While doing so, the mailer utilizes the built-in
       
                                     -10-



       editor module of MMScan or the user defined editor. Changes will
       either be saved by selecting F2 or discarded by depressing F10.
       The text editing feature offers one additional bonus as it
       allows to view the entire message including the header. This
       feature is useful to verify the settings of the MMSCan
       configuration (mmscan.cfg) file.

       CAUTION: Editing of the work or the message text while a NOS
       is running, may lead to undesirable consequences. It is perhaps
       advisable to disable either the NOS or the SMTP process while
       editing.




                (4) Navigating the Mail Browser


       Select the mail box to be viewed or browsed from the opening menu
       by moving the highlighted cursor bar to the respective box and
       select by pressing ENTER or the spacebar.

             Note: If a user defined browser/viewer such as 'list.com'
             is configured, the following features will not be available
             to the user.

       The mailer presents next the browser index screen. The top status
       line identifies the active mail box, the number of messages in the
       respective box and any new messages.

       The commands available from this screen are:


       alias    alias file editing or viewing (discussed previously)
       new      moves immediately to first encountered new messages
       undo     undeletes message or removes tagged message status
                indicator
       Del      marks message for deletion
       Tag      tags message for 'batch manipulation'
       save     saves highlighted or tagged message(s)
       print    prints highlighted or tagged message(s)
       bounce   highlighted or tagged message(s) will be bounced without
                allowing changes of contents
       mail     mail a message (discussed previously)
       tx file  transmit an ASCII or binary file (discussed previously)
       fwd      message will be forwarded with comments
       reply    reply to message
       
                                     -11-



       special commands shown on bottom of the screen (line 25):
       >        copy mail to another box
       ?        text search function
       ,        repeat of text search

       Since some of the commands are not self explanatory, they
       will be described below:



       >>> Tag <<<


       This command will mark messages for bulk processing. It is only
       active when saving, printing or bouncing messages. As an
       alternate to the letter key 'T', the '+' key can be used to tag.
       Conversly the '-' key will untag.


       >>> save <<<

       This command will save the message where the highlighted cursor
       bar is located or several tagged messages to a file named
       according to the mailbox but with the file extension '.sav'.
       Example: saved mail from mailbox dl1bjl becomes 'dl1bjl.sav'.
       Messages are appended to previously saved messages and the files
       are located (saved) in the mail directory.
       This feature is quite useful for message management as it allows
       clearance of active mail boxes and safe archiving of important
       messages.


       >>> print <<<

       Entering 'p' will either print a single message highlighted by the
       cursor bar or print all tagged messages without operator
       intervention - a great feature. Printing will be directed to the
       respective LPT device as designated in the configuration file.
       (It has been tested on dot matrix and laser printers)


       >>> bounce <<<

       This feature has several uses. Firstly, mail can simply be bounced
       via SMTP to an external address without modifying the message text
       and secondly, the message may be bounced to another mailbox
       internal to the host, or both. Alias addressing and carbon copying
       provides for additional flexibility to move a message (or messages
       when tagged) to the required destination.
       
                                     -12-



       >>> fwd <<<

       Forwarding a message makes use of the defined editor in the
       mailer. Upon selecting this feature, the user is prompted for an
       address or an alias. Carbon copies to an address or one or several
       aliases, following the addressing scheme discussed earlier, are
       also allowed. The 'subject' field is pre-loaded with the subject
       heading of the forwarded message, but it is modifiable. The editor
       positions the cursor beneath a comment line for insertion of user
       comments.


       >>> reply <<<

       This feature is a variant of forwarding with the exception that
       the user has the choice whether or not to include the message
       which is being answered. The reply address and subject matter
       are already pre-loaded for convenience but can be modified if
       required.


       --- > ---

       The 'greater than' character invokes the copy mail function. It
       allows copying of one or several messages to another mailbox
       without the intervention of NOS (as in bounce). In the event that
       several messages have to be moved, the tag function is used to tag
       the messages. The mailer prompts for the name of the destination
       mail box (area). If it does not exist, it will be created. In
       addition, the copied messages(s) are marked deleted (D) in the
       source mail box after the function is completed. However, the
       'U'ndo function will mark the message(s) as read (R).


       --- ? ---

       This function allows searching of the message FROM: and SUBJECT:
       fields for user defined search criteria. This function works
       similar to hypertext searches.
       Searches start always at the top of the mail box.


       --- ' ---

       Hitting the komma key will perform repeat searches, utilizing the
       same criteria defined previously until the end of the mail box is
       reached.
       
                                     -13-



                (5) Navigating the Mail Reader/Viewer


       The mail reader/viewer screen will be accessed from the
       mail browser screen by selecting the appropriate mailbox or area.

       The commands available from this screen are shown in the top and
       bottom status lines bars respectively.

       Following is a brief description of the commands:



       >>> top of message <<<

       Depressing 't' brings the cursor back to the beginning of the
       message.


       >>> toggle header <<<

       This feature allows viewing of the message in its entirety,
       including the message header and the corresponding routing and
       handling information.


       >>> print message <<<

       Depressing 'p' will print the entire message to the pre-defined
       LPT device port. This will print only a single message as opposed
       to bulk printing which is available from the mail browser screen.


       >>> save file <<<

       This is a rather interesting feature in that MMScan senses
       the type of file to be saved. Therefore, whether the message
       consists of plain text or a MIME base 64 encoded binary file, the
       user will be prompted as to the action to take in order to save
       the message. At that point, the user has a choice of file name
       and sub directory. If a file is a MIME base-64 encoded binary file
       (which appears as random ASCII characters) it will be decoded
       (converted) into its original form. Conversly, if a file is a
       plain text file, it will be saved as such.

       The commands shown in the bar at the bottom of the screen, direct
       the user to movements within the message body and escape action
       possible.
       
                                     -14-



                (6) The Directory File Viewer/Browser Window

       This feature is invoked whenever MMScan requests the name of a
       file. 'What file?' is the precise prompt. This prompt appears
       bevor events where a file name is required. This is specifically
       the case when sending a file, or wanting to attach a file to
       mail, or simply when editing a file. The routine is called when
       either the field after the prompt 'What file?' is left blank or
       when only drive letter and a path to a directory are entered.
       If the field is left blank and after depressing ENTER, a window is
       opened at the left hand side of the screen. The window will
       display the directory structure of the currently logged
       sub-directory and its corresponding files. The arrow keys allows
       moving up and down the directories. A quick way to locate a
       particular file is to just type the beginning letters of the file.
       The cursor will move rapidly to the location of the respective
       file with the matching letters. Moreover, users can 'drill down'
       into sub-directories by depressing ENTER with the cursor positioned
       at a sub-directory. Conversely, selection of the '..' (parent
       directory) will allow moving up the directory tree.
       To select and anchor a file, the ENTER key must be depressed.
       While in the window, the user also has the possibility to
       view the contents of a text file. The highlighted cursor
       is moved to the file to be viewed and depressing the
       spacebar will display (list) the contents of the file.
       When a valid drive letter is entered at the prompt, selection of
       drives and its directories are possible.
       
                                       -15-



       5. APPENDIX

       1. MIME Implementation in MMScan

       MIME (Multipurpose Internet Mail Extensions) provides a standard
       framework, which was described in RFCs 1341 to 1344, to exchange
       and recognize messages of infinitely variable content. Thus,
       content could be images and sound in addition to binary files and
       plain text. MIME has been designed to handle this 'multi media'
       content on top of the SMTP (Simple Mail Transfer Protocol)
       infrastructure.

       This, very briefly, summarizes what MIME stands for and what it is
       designed to do. It is really beyond the scope of this manual to
       extensively dwell on the rather complex subject matter. But let it
       suffice to say that MMScan contains a limited implementation of
       the MIME standard which allows the software to recognize MIME base
       64 encoded text to be created to transmit binary files as well as
       the corresponding recognition of the MIME encoding scheme for
       conversion of encoded text into its original state. For the very
       curious, we have included an excerpt of RFC 1341 which describes
       the base 64 octet stream encoding and decoding scheme below.


       2. Extract of RFC 1341


              Network Working Group               N. Borenstein, Bellcor
            Request for Comments: 1341               N. Freed, Innosoft
                                                              June 1992



                   MIME  (Multipurpose Internet Mail Extensions):


                      Mechanisms for Specifying and Describing
                       the Format of Internet Message Bodies


          Status of this Memo

            This RFC specifies an IAB standards track protocol  for  the
            Internet  community, and requests discussion and suggestions
            for improvements.  Please refer to the  current  edition  of
            the    "IAB    Official    Protocol   Standards"   for   the
            standardization  state  and   status   of   this   protocol.
            Distribution of this memo is unlimited.

          Abstract

            RFC 822 defines  a  message  representation  protocol  which
            specifies  considerable  detail  about  message headers, but
            which leaves the message content, or message body,  as  flat
            ASCII  text.   This document redefines the format of message
        
                                       -16-



            bodies to allow multi-part textual and  non-textual  message
            bodies  to  be  represented  and  exchanged  without loss of
            information.   This is based on earlier work  documented  in
            RFC  934  and  RFC  1049, but extends and revises that work.
            Because RFC 822 said so little about  message  bodies,  this
            document  is  largely  orthogonal to (rather than a revision
            of) RFC 822.
            In  particular,  this  document  is  designed   to   provide
            facilities  to include multiple objects in a single message,
            to represent body text in  character  sets  other  than  US-
            ASCII,  to  represent formatted multi-font text messages, to
            represent non-textual material  such  as  images  and  audio
            fragments,  and  generally  to  facilitate  later extensions
            defining new types of Internet mail for use  by  cooperating
            mail agents.

            This document does NOT extend Internet mail header fields to
            permit  anything  other  than  US-ASCII  text  data.   It is
            recognized that such extensions are necessary, and they  are
            the subject of a companion document [RFC -1342].

            A table of contents appears at the end of this document.





                Introduction

            Since its publication in 1982, RFC 822 [RFC-822] has defined
            the   standard  format  of  textual  mail  messages  on  the
            Internet.  Its success has been such that the RFC 822 format
            has  been  adopted,  wholly  or  partially,  well beyond the
            confines of the Internet and  the  Internet  SMTP  transport
            defined  by RFC 821 [RFC-821].  As the format has seen wider
            use,  a  number  of  limitations  have  proven  increasingly
            restrictive for the user community.

            RFC 822 was intended to specify a format for text  messages.
            As such, non-text messages, such as multimedia messages that
            might include audio or images,  are  simply  not  mentioned.
            Even in the case of text, however, RFC 822 is inadequate for
            the needs of mail users whose languages require the  use  of
            character  sets  richer  than US ASCII [US-ASCII]. Since RFC
            822 does not specify mechanisms for mail  containing  audio,
            video,  Asian  language  text, or even text in most European
            languages, additional specifications are needed

            One of the notable limitations of  RFC  821/822  based  mail
            systems  is  the  fact  that  they  limit  the  contents  of
            electronic  mail  messages  to  relatively  short  lines  of
            seven-bit  ASCII.   This  forces  users  to convert any non-
            textual data that they may wish to send into seven-bit bytes
       
                                       -17-



            representable  as printable ASCII characters before invoking
            a local mail UA (User Agent,  a  program  with  which  human
            users  send  and  receive  mail). Examples of such encodings
            currently used in the  Internet  include  pure  hexadecimal,
            uuencode,  the  3-in-4 base 64 scheme specified in RFC 1113,
            the Andrew Toolkit Representation [ATK], and many others.

            The limitations of RFC 822 mail become even more apparent as
            gateways  are  designed  to  allow  for the exchange of mail
            messages between RFC 822 hosts and X.400 hosts. X.400 [X400]
            specifies  mechanisms  for the inclusion of non-textual body
            parts  within  electronic  mail   messages.    The   current
            standards  for  the  mapping  of  X.400  messages to RFC 822
            messages specify that either X.400  non-textual  body  parts
            should  be converted to (not encoded in) an ASCII format, or
            that they should be discarded, notifying the  RFC  822  user
            that  discarding has occurred.  This is clearly undesirable,
            as information that a user may  wish  to  receive  is  lost.
            Even  though  a  user's  UA  may  not have the capability of
            dealing with the non-textual body part, the user might  have
            some  mechanism  external  to the UA that can extract useful
            information from the body part.  Moreover, it does not allow
            for  the  fact  that the message may eventually be gatewayed
            back into an X.400 message handling system (i.e., the  X.400
            message  is  "tunnelled"  through  Internet  mail), where the
            non-textual  information  would  definitely  become   useful
            again.


            This document describes several mechanisms that  combine  to
            solve most of these problems without introducing any serious
            incompatibilities with the existing world of RFC  822  mail.
            In particular, it describes:

            1.  A MIME-Version header field, which uses a version number
                 to  declare  a  message  to  be  conferment  with  this
                 specification and  allows  mail  processing  agents  to
                 distinguish  between  such messages and those generated
                 by older or non-conferment software, which is  presumed
                 to lack such a field.

            2.  A Content-Type header field, generalized from  RFC  1049
                 [RFC-1049],  which  can be used to specify the type and
                 subtype of data in the body of a message and  to  fully
                 specify  the  native  representation (encoding) of such
                 data.

                 2.a.  A "text" Content-Type value, which can be used to
                      represent  textual  information  in  a  number  of
                      character  sets  and  formatted  text  description
                      languages in a standardized manner.

                 2.b.  A "multipart" Content-Type value,  which  can  be
                      used  to  combine  several body parts, possibly of
                      differing types of data, into a single message.
       
                                       -18-



                 2.c.  An "application" Content-Type value, which can be
                      used  to transmit application data or binary data,
                      and hence,  among  other  uses,  to  implement  an
                      electronic mail file transfer service.

                 2.d.  A "message" Content-Type value, for encapsulating
                      a mail message.

                 2.e  An "image"  Content-Type value,  for  transmitting
                      still image (picture) data.

                 2.f.  An "audio"  Content-Type value, for  transmitting
                      audio or voice data.

                 2.g.  A "video"  Content-Type value,  for  transmitting
                      video or moving image data, possibly with audio as
                      part of the composite video data format.

            3.  A Content-Transfer-Encoding header field, which  can  be
                 used  to specify an auxiliary encoding that was applied
                 to the data in order to allow it to pass  through  mail
                 transport  mechanisms  which may have data or character
                 set limitations.

            4.  Two optional header fields that can be used  to  further
                 describe the data in a message body, the Content-ID and
                 Content-Description header fields.


            MIME has been carefully designed as an extensible mechanism,
            and  it  is  expected  that  the set of content-type/subtype
            pairs   and   their   associated   parameters   will    grow
            significantly with time.  Several other MIME fields, notably
            including character set names, are likely to have new values
            defined  over time.  In order to ensure that the set of such
            values is  developed  in  an  orderly,  well-specified,  and
            public  manner,  MIME  defines  a registration process which
            uses the Internet Assigned Numbers  Authority  (IANA)  as  a
            central  registry  for  such  values.   Appendix  F provides
            details about how IANA registration is accomplished.

            Finally, to specify and promote interoperability, Appendix A
            of  this  document  provides a basic applicability statement
            for a subset of the above mechanisms that defines a  minimal
            level of "conformance" with this document.

            HISTORICAL NOTE:  Several of  the  mechanisms  described  in
            this  document  may seem somewhat strange or even baroque at
            first reading.  It is important to note  that  compatibility
            with  existing  standards  AND  robustness  across  existing
            practice were two of the highest priorities of  the  working
            group   that   developed   this  document.   In  particular,
            compatibility was always favoured over elegance.

          
                                      -19-



               Base64 Content-Transfer-Encoding

            The  Base64   Content-Transfer-Encoding   is   designed   to
            represent  arbitrary  sequences  of octets in a form that is
            not humanly readable.  The encoding and decoding  algorithms
            are simple, but the encoded data are consistently only about
            33 percent larger than the unencoded data.  This encoding is
            based on the one used in Privacy Enhanced Mail applications,
            as defined in RFC 1113.   The  base64  encoding  is  adapted
            from  RFC  1113, with one change:  base64 eliminates the "*"
            mechanism for embedded clear text.

            A 65-character subset of US-ASCII is used, enabling  6  bits
            to  be  represented per printable character. (The extra 65th
            character, "=", is used  to  signify  a  special  processing
            function.)

            NOTE:  This subset has the important  property  that  it  is
            represented   identically   in  all  versions  of  ISO  646,
            including US ASCII, and all characters  in  the  subset  are
            also  represented  identically  in  all  versions of EBCDIC.
            Other popular encodings, such as the encoding  used  by  the
            UUENCODE  utility  and the base85 encoding specified as part
            of Level 2 PostScript, do not share  these  properties,  and
            thus  do  not  fulfil the portability requirements a binary
            transport encoding for mail must meet.
            The encoding process represents 24-bit groups of input  bits
            as  output  strings of 4 encoded characters. Proceeding from
            left  to  right,  a  24-bit  input  group   is   formed   by
            concatenating  3  8-bit input groups. These 24 bits are then
            treated as 4 concatenated 6-bit groups,  each  of  which  is
            translated  into a single digit in the base64 alphabet. When
            encoding a bit stream  via  the  base64  encoding,  the  bit
            stream  must  be  presumed  to  be  ordered  with  the most-
            significant-bit first.  That is, the first bit in the stream
            will be the high-order bit in the first byte, and the eighth
            bit will be the low-order bit in the first byte, and so on.

            Each 6-bit group is used as an index into  an  array  of  64
            printable  characters. The character referenced by the index
            is placed in the output string. These characters, identified
            in  Table  1,  below,  are  selected so as to be universally
            representable,  and  the  set   excludes   characters   with
            particular  significance to SMTP (e.g., ".", "CR", "LF") and
            to the encapsulation boundaries  defined  in  this  document
            (e.g., "-").

       
                                       -20-



                            Table 1: The Base64 Alphabet

               Value Encoding  Value  Encoding   Value  Encoding   Value
            Encoding
                   0 A            17 R            34 i            51 z
                   1 B            18 S            35 j            52 0
                   2 C            19 T            36 k            53 1
                   3 D            20 U            37 l            54 2
                   4 E            21 V            38 m            55 3
                   5 F            22 W            39 n            56 4
                   6 G            23 X            40 o            57 5
                   7 H            24 Y            41 p            58 6
                   8 I            25 Z            42 q            59 7
                   9 J            26 a            43 r            60 8
                  10 K            27 b            44 s            61 9
                  11 L            28 c            45 t            62 +
                  12 M            29 d            46 u            63 /
                  13 N            30 e            47 v
                  14 O            31 f            48 w         (pad) =
                  15 P            32 g            49 x
                  16 Q            33 h            50 y

            The output stream (encoded bytes)  must  be  represented  in
            lines  of  no more than 76 characters each.  All line breaks
            or other characters not found in Table 1 must be ignored  by
            decoding  software.   In  base64 data, characters other than
            those in  Table  1,  line  breaks,  and  other  white  space
            probably  indicate  a  transmission  error,  about  which  a
            warning  message  or  even  a  message  rejection  might  be
            appropriate under some circumstances.

            Special processing is performed if fewer than  24  bits  are
            available  at  the  end  of  the data being encoded.  A full
            encoding quantum is always completed at the end of  a  body.
            When  fewer  than  24  input  bits are available in an input
            group, zero bits  are  added  (on  the  right)  to  form  an
            integral number of 6-bit groups.  Output character positions
            which are not required to represent actual  input  data  are
            set  to  the  character  "=".   Since all base64 input is an
            integral number of octets,  only  the  following  cases  can
            arise:  (1)  the  final  quantum  of  encoding  input  is an
            integral multiple of  24  bits;  here,  the  final  unit  of
            encoded  output will be an integral multiple of 4 characters
            with no "=" padding, (2) the final quantum of encoding input
            is  exactly  8  bits; here, the final unit of encoded output
            will  be  two  characters  followed  by  two   "="   padding
            characters,  or  (3)  the final quantum of encoding input is
            exactly 16 bits; here, the final unit of encoded output will
            be three characters followed by one "=" padding character.
       
                                       -21-



            Care must be taken to use the proper octets for line  breaks
            if base64 encoding is applied directly to text material that
            has not been converted to  canonical  form.  In  particular,
            text  line  breaks  should  be converted into CRLF sequences
            prior to base64 encoding. The important  thing  to  note  is
            that this may be done directly by the encoder rather than in
            a prior canonicalization step in some implementations.

            NOTE: There is no  need  to  worry  about  quoting  apparent
            encapsulation  boundaries  within  base64-encoded  parts  of
            multipart entities because no hyphen characters are used  in
            the base64 encoding.
       
                                       -22-



            3. Version History

            Version 1.1    Launched on Dezember 14, 1994

            Version 1.1a   Fixed a bug that caused random dropping
                           of text in the last message of a mail file if the
                           mailbox is updated after deleting mails. 94/12/19.

            Version 1.2    Fixed a bug that did not show new mail after
                           deleting mail.

                           New functions: '?' and ',' for searching items
                           in From:- and Subject-lines. ',' repeats the last
                           search.

                           Destination MBox is now limited to 8 chars when
                           moving messages. Wrong input did exit with
                           a runtime error.

                           File TX: This function now detects
                           binary or ASCII file selection. In
                           case of binary, MIME-encoding is done.

                           Some little cosmetics, e.g. a summary field in
                           the main menu.  95/02/08
            
